## vim 9.1.1882

=== nsis/Makefile ===
#
# Makefile for UNIX-like for create self-installing exe of Vim.
# 2025-10-03, Restorer, restorer@mail2k.ru
#


.SUFFIXES:
.PHONY: all makeinst prepare rename clean 

ifdef VIMSRC
MKNSISFLAGS := -D"VIMSRC=$(VIMSRC)"
endif

ifdef VIMRT
MKNSISFLAGS := $(MKNSISFLAGS) -D"VIMRT=$(VIMRT)"
endif

ifdef VIMTOOLS
MKNSISFLAGS := $(MKNSISFLAGS) -D"VIMTOOLS=$(VIMTOOLS)"
endif

ifdef GETTEXT
MKNSISFLAGS := $(MKNSISFLAGS) -D"GETTEXT=$(GETTEXT)"
endif

ifdef HAVE_UPX
MKNSISFLAGS := $(MKNSISFLAGS) -DHAVE_UPX=$(HAVE_UPX)
endif

ifdef HAVE_NLS
MKNSISFLAGS := $(MKNSISFLAGS) -DHAVE_NLS=$(HAVE_NLS)
endif

ifdef HAVE_MULTI_LANG
MKNSISFLAGS := $(MKNSISFLAGS) -DHAVE_MULTI_LANG=$(HAVE_MULTI_LANG)
endif

ifdef WIN64
MKNSISFLAGS := $(MKNSISFLAGS) -DWIN64=$(WIN64)
endif

ifdef ARM64
MKNSISFLAGS := $(MKNSISFLAGS) -DARM64=$(ARM64)
endif

ifdef INCLUDE_LIBGCC
MKNSISFLAGS := $(MKNSISFLAGS) -DINCLUDE_LIBGCC=$(INCLUDE_LIBGCC)
endif

ifdef X
XX := -X"$(X:;=" -X")"
endif

MKNSISFLAGS := -INPUTCHARSET UTF8 $(MKNSISFLAGS)

all: makeinst

makeinst: prepare
	makensis $(MKNSISFLAGS) gvim.nsi $(XX)

prepare: unzipicons license rename

unzipicons: icons.zip
	if test -d `basename $? .zip` ; then rm -rf `basename $? .zip` ; fi
	unzip $?

license: ../lang/LICENSE.*.txt ../LICENSE
	for lic in $? ; do \
		bn=`basename $$lic .txt` ; \
		awk 'sub("$$", "\r")' < $$lic | \
		iconv -f UTF-8 -t UTF-16 > ../lang/$$bn.nsis.txt ; \
	done

rename:
	../tools/rename.bat "$(SRC)" "$(DST)"

clean:
	rm -f ../lang/LICENSE*.nsis.txt
	if test -d icons ; then rm -rf icons ; fi
	if test -f gvim??.exe ; then rm -f gvim??.exe ; fi

# vim: set noet sw=8 ts=8 sts=0 wm=0 tw=0 ft=make:

=== src/Makefile ===
# Makefile for Vim on Unix and Unix-like systems	vim:ts=8:sw=8:tw=78
#
# This Makefile is loosely based on the GNU Makefile conventions found in
# standards.info.
#
# Compiling Vim, summary:
#
#	3. make
#	5. make install
#
# Compiling Vim, details:
#
# Edit this file for adjusting to your system. You should not need to edit any
# other file for machine specific things!
# The name of this file MUST be Makefile (note the uppercase 'M').
#
# 1. Edit this Makefile  {{{1
#	The defaults for Vim should work on most machines, but you may want to
#	uncomment some lines or make other changes below to tune it to your
#	system, compiler or preferences.  Uncommenting means that the '#' in
#	the first column of a line is removed.
#	- If you want a version of Vim that is small and starts up quickly,
#	  you might want to disable the GUI, X11, Perl, Python and Tcl.
#	- Uncomment the line with --disable-gui if you have Motif and/or GTK
#	  but don't want to make gvim (the GUI version of Vim with nice
#	  menus and scrollbars, but makes Vim bigger and startup slower).
#	- Uncomment --disable-darwin if on Mac OS X but you want to compile a
#	  Unix version.
#	- Uncomment the line "CONF_OPT_X = --without-x" if you have X11 but
#	  want to disable using X11 libraries.	This speeds up starting Vim,
#	  but the window title will not be set and the X11 selection can not
#	  be used.
#	- Uncomment the line "CONF_OPT_XSMP = --disable-xsmp" if you have the
#	  X11 Session Management Protocol (XSMP) library (libSM) but do not
#	  want to use it.
#	  This can speedup Vim startup but Vim loses the ability to catch the
#	  user logging out from session-managers like GNOME and work
#	  could be lost.
#	- Uncomment one or more of these lines to include an interface;
#	  each makes Vim quite a bit bigger:
#		--enable-luainterp	for Lua interpreter
#		--enable-mzschemeinterp	for MzScheme interpreter
#		--enable-perlinterp	for Perl interpreter
#		--enable-python3interp	for Python3 interpreter
#		--enable-pythoninterp	for Python interpreter
#		--enable-rubyinterp	for Ruby interpreter
#		--enable-tclinterp	for Tcl interpreter
#		--enable-cscope		for Cscope interface
#	- Uncomment one of the lines with --with-features= to enable a set of
#	  features (but not the interfaces just mentioned).
#	- Uncomment the line with --disable-acl to disable ACL support even
#	  though your system supports it.
#	- Uncomment the line with --disable-gpm to disable gpm support
#	  even though you have gpm libraries and includes.
#	- Uncomment the line with --disable-sysmouse to disable sysmouse
#	  support even though you have /dev/sysmouse and includes.
#	- Uncomment one of the lines with CFLAGS and/or CC if you have
#	  something very special or want to tune the optimizer.
#	- Search for the name of your system to see if it needs anything
#	  special.
#	- A few versions of make use '.include "file"' instead of 'include
#	  file'.  Adjust the include line below if yours does.
#
# 2. Edit feature.h  {{{1
#	Only if you do not agree with the default compile features, e.g.:
#	- you want Vim to be as vi compatible as it can be
#	- you want to use Emacs tags files
#	- you want right-to-left editing (Hebrew)
#	- you want 'langmap' support (Greek)
#	- you want to remove features to make Vim smaller
#
# 3. "make"  {{{1
#	Will first run ./configure with the options in this file. Then it will
#	start make again on this Makefile to do the compiling. You can also do
#	this in two steps with:
#		make config
#		make
#	The configuration phase creates/overwrites auto/config.h and
#	auto/config.mk.
#	The configure script is created with "make autoconf".  It can detect
#	different features of your system and act accordingly.  However, it is
#	not correct for all systems.  Check this:
#	- If you have X windows, but configure could not find it or reported
#	  another include/library directory then you wanted to use, you have
#	  to set CONF_OPT_X below.  You might also check the installation of
#	  xmkmf.
#	- If you have --enable-gui=motif and have Motif on your system, but
#	  configure reports "checking for location of gui... <not found>", you
#	  have to set GUI_INC_LOC and GUI_LIB_LOC below.
#	If you changed something, do this to run configure again:
#		make reconfig
#
#	- If you do not trust the automatic configuration code, then inspect
#	  auto/config.h and auto/config.mk, before starting the actual build
#	  phase. If possible edit this Makefile, rather than auto/config.mk --
#	  especially look at the definition of VIMLOC below. Note that the
#	  configure phase overwrites auto/config.mk and auto/config.h again.
#	- If you get error messages, find out what is wrong and try to correct
#	  it in this Makefile. You may need to do "make reconfig" when you
#	  change anything that configure uses (e.g. switching from an old C
#	  compiler to an ANSI C compiler). Only when auto/configure does
#	  something wrong you may need to change one of the other files. If
#	  you find a clean way to fix the problem, consider sending a note to
#	  the author of autoconf (bug-gnu-utils@prep.ai.mit.edu) or Vim
#	  (vim-dev@vim.org). Don't bother to do that when you made a hack
#	  solution for a non-standard system.
#
# 4. "make test"  {{{1
#	This is optional.  This will run Vim scripts on a number of test
#	files, and compare the produced output with the expected output.
#	If all is well, you will get the "ALL DONE" message in the end.  If a
#	test fails you get "TEST FAILURE".  See below (search for "/^test").
#
# 5. "make install"  {{{1
#	If the new Vim seems to be working OK you can install it and the
#	documentation in the appropriate location. The default is
#	"/usr/local".  Change "prefix" below to change the location.
#	"auto/pathdef.c" will be compiled again after changing this to make
#	the executable know where the help files are located.
#	Note that any existing executable is removed or overwritten.  If you
#	want to keep it you will have to make a backup copy first.
#	The runtime files are in a different directory for each version.  You
#	might want to delete an older version.
#	If you don't want to install everything, there are other targets:
#		make installvim		only installs Vim, not the tools
#		make installvimbin	only installs the Vim executable
#		make installruntime	installs most of the runtime files
#		make installrtbase	only installs the Vim help and
#							runtime files
#		make installlinks	only installs the Vim binary links
#		make installmanlinks	only installs the Vim manpage links
#		make installmacros	only installs the Vim macros
#		make installpack	only installs the packages
#		make installtutorbin	only installs the Vim tutor program
#		make installtutor	only installs the Vim tutor files
#		make installspell	only installs the spell files
#		make installtools	only installs xxd
#	If you install Vim, not to install for real but to prepare a package
#	or RPM, set DESTDIR to the root of the tree.
#
# 6. Use Vim until a new version comes out.  {{{1
#
# 7. "make uninstall_runtime"  {{{1
#	Will remove the runtime files for the current version.	This is safe
#	to use while another version is being used, only version-specific
#	files will be deleted.
#	To remove the runtime files of another version:
#		make uninstall_runtime VIMRTDIR=/vim54
#	If you want to delete all installed files, use:
#		make uninstall
#	Note that this will delete files that have the same name for any
#	version, thus you might need to do a "make install" soon after this.
#	Be careful not to remove a version of Vim that is still being used!
#	To find out which files and directories will be deleted, use:
#		make -n uninstall
# }}}
#
### This Makefile has been successfully tested on many systems. {{{
### Only the ones that require special options are mentioned here.
### Check the (*) column for remarks, listed below.
### Later code changes may cause small problems, otherwise Vim is supposed to
### compile and run without problems.

#system:	      configurations:		     version (*) tested by:
#-------------	      ------------------------	     -------  -  ----------
#AIX 3.2.5	      cc (not gcc)   -			4.5  (M) Will Fiveash
#AIX 4		      cc	     +X11 -GUI		3.27 (4) Axel Kielhorn
#AIX 4.1.4	      cc	     +X11 +GUI		4.5  (5) Nico Bakker
#AIX 4.2.1	      cc				5.2k (C) Will Fiveash
#AIX 4.3.3.12	      xic 3.6.6				5.6  (5) David R. Favor
#A/UX 3.1.1	      gcc	     +X11		4.0  (6) Jim Jagielski
#BSDI 2.1 (x86)       shlicc2 gcc-2.6.3 -X11 X11R6	4.5  (1) Jos Backus
#BSD/OS 3.0 (x86)     gcc gcc-2.7.2.1 -X11 X11R6	4.6c (1) Jos Backus
#CX/UX 6.2	      cc	     +X11 +GUI_Mofif	5.4  (V) Kipp E. Howard
#DG/UX 5.4*	      gcc 2.5.8      GUI		5.0e (H) Jonas Schlein
#DG/UX 5.4R4.20       gcc 2.7.2      GUI		5.0s (H) Rocky Olive
#HP-UX (most)	      c89 cc				5.1  (2) Bram Moolenaar
#HP-UX_9.04	      cc	     +X11 +Motif	5.0  (2) Carton Lao
#Linux 2.0	      gcc-2.7.2      Infomagic Motif	4.3  (3) Ronald Rietman
#NEC UP4800 UNIX_SV 4.2MP  cc	     +X11R6 Motif	4.6b (Q) Lennart Schultz
#NetBSD 1.0A	      gcc-2.4.5      -X11 -GUI		3.21 (X) Juergen Weigert
#QNX 4.2	      wcc386-10.6    -X11		4.2  (D) G.F. Desrochers
#QNX 4.23	      Watcom	     -X11		4.2  (F) John Oleynick
#SCO Unix v3.2.5      cc	     +X11 Motif		3.27 (C) M. Kuperblum
#SCO Open Server 5    gcc 2.7.2.3    +X11 +GUI Motif	5.3  (A) Glauber Ribeiro
#SINIX-N 5.43 RM400 R4000   cc	     +X11 +GUI		5.0l (I) Martin Furter
#SINIX-Z 5.42 i386    gcc 2.7.2.3    +X11 +GUI Motif	5.1  (I) Joachim Fehn
#SINIX-Y 5.43 RM600 R4000  gcc 2.7.2.3 +X11 +GUI Motif	5.1  (I) Joachim Fehn
#Reliant/SINIX 5.44   cc	     +X11 +GUI		5.5a (I) B. Pruemmer
#SNI Targon31 TOS 4.1.11 gcc-2.4.5   +X11 -GUI		4.6c (B) Paul Slootman
#Solaris 2.4 (Sparc)  cc	     +X11 +GUI		3.29 (9) Glauber
#Solaris 2.4/2.5      clcc	     +X11 -GUI openwin	3.20 (7) Robert Colon
#Solaris 2.5 (sun4m)  cc (SC4.0)     +X11R6 +GUI (CDE)	4.6b (E) Andrew Large
#Solaris 2.5	      gcc 2.5.6      +X11 Motif		5.0m (R) Ant. Colombo
#Solaris 2.6	      gcc 2.8.1      ncurses		5.3  (G) Larry W. Virden
#Solaris with -lthread					5.5  (W) K. Nagano
#Solaris	      gcc				     (b) Riccardo
#SunOS 4.1.x			     +X11 -GUI		5.1b (J) Bram Moolenaar
#SUPER-UX 6.2 (NEC SX-4) cc	     +X11R6 Motif	4.6b (P) Lennart Schultz
#Tandem/NSK						     (c) Matthew Woehlke
#Unisys 6035	      cc	     +X11 Motif		5.3  (8) Glauber Ribeiro
#ESIX V4.2	      cc	     +X11		6.0  (a) Reinhard Wobst
# }}}

# (*)  Remarks: {{{
#
# (1)  Uncomment line below for shlicc2
# (2)  HPUX with compile problems or wrong digraphs, uncomment line below
# (3)  Infomagic Motif needs GUI_LIB_LOC and GUI_INC_LOC set, see below.
#      And add "-lXpm" to MOTIF_LIBS2.
# (4)  For cc the optimizer must be disabled (use CFLAGS= after running
#      configure) (symptom: ":set termcap" output looks weird).
# (5)  Compiler may need extra argument, see below.
# (6)  See below for a few lines to uncomment
# (7)  See below for lines which enable the use of clcc
# (8)  Needs some EXTRA_LIBS, search for Unisys below
# (9)  Needs an extra compiler flag to compile gui_at_sb.c, see below.
# (A)  May need EXTRA_LIBS, see below
# (B)  Can't compile GUI because there is no waitpid()...  Disable GUI below.
# (C)  Force the use of curses instead of termcap, see below.
# (D)  Uncomment lines below for QNX
# (E)  You might want to use termlib instead of termcap, see below.
# (F)  See below for instructions.
# (G)  Using ncurses version 4.2 has reported to cause a crash.  Use the
#      Sun curses library instead.
# (H)  See line for EXTRA_LIBS below.
# (I)  SINIX-N 5.42 and 5.43 need some EXTRA_LIBS.  Also for Reliant-Unix.
# (J)  If you get undefined symbols, see below for a solution.
# (K)  See lines to uncomment below for machines with 64 bit pointers.
# (L)  For Silicon Graphics O2 workstations remove "-lnsl" from auto/config.mk
# (M)  gcc version cygnus-2.0.1 does NOT work (symptom: "dl" deletes two
#      characters instead of one).
# (N)  SCO with decmouse.

=== runtime/syntax/Makefile ===
# Portable Makefile for running syntax tests.

# To run the test manually:
# ../../src/vim -u 'testdir/runtest.vim' --cmd 'breakadd func RunTest'

# Override this if needed, the default assumes Vim was built in the src dir.
#VIMPROG = vim
VIMPROG = ../../src/vim

# "runtime" relative to "runtime/syntax/testdir"
VIMRUNTIME = ../..

# Uncomment this line to use valgrind for memory leaks and extra warnings.
# VALGRIND = valgrind --tool=memcheck --leak-check=yes --num-callers=45 --log-file=valgrind.$*

# Trace liveness on demand.
# VIM_SYNTAX_TEST_LOG = `pwd`/testdir/failed/00-TRACE_LOG

# ENVVARS = LC_ALL=C VIM_SYNTAX_TEST_LOG="$(VIM_SYNTAX_TEST_LOG)"
# ENVVARS = LC_ALL=C LANG=C LANGUAGE=C
# Run the syntax tests with a C locale
ENVVARS = LC_ALL=C

RUN_VIMTEST = VIMRUNTIME=$(VIMRUNTIME) $(VALGRIND) $(ENVVARS) ../$(VIMPROG) -f $(GUI_FLAG)

# Uncomment this line for debugging
# DEBUGLOG = --log testlog

# All initial phony targets; these names may clash with file types.
phonies = clean test testclean
.PHONY: $(phonies)

# Run the tests that didn't run yet or failed previously.
# If a test succeeds a testdir/done/{name} file will be written.
# If a test fails a testdir/failed/{name}.dump file will be written.
# Progress and error messages can be found in "testdir/messages".
# Comment out the "> /dev/null" part to see the in-progress Vim behaviors.
test:
	@# the "vimcmd" file is used by the screendump utils
	@echo "../$(VIMPROG)" > testdir/vimcmd
	@echo "$(RUN_VIMTEST)" >> testdir/vimcmd
	@# Trace liveness on demand.
	@#mkdir -p testdir/failed
	@#touch "$(VIM_SYNTAX_TEST_LOG)"
	VIMRUNTIME=$(VIMRUNTIME) $(ENVVARS) $(VIMPROG) --clean --not-a-term $(DEBUGLOG) -u testdir/runtest.vim > /dev/null
	@# FIXME: Temporarily show the whole file to find out what goes wrong
	@#if [ -f testdir/messages ]; then tail -n 6 testdir/messages; fi
	@if [ -f testdir/messages ]; then cat testdir/messages; fi

# add dependence on syntax files
testdir/testdeps.mk:
	./testdir/tools/maketestdeps $(phonies) > $@

-include testdir/testdeps.mk

clean testclean:
	rm -f testdir/failed/* testdir/done/* testdir/vimcmd testdir/messages testdir/Xtestscript testdir/Xfilter testdir/testdeps.mk

# Collect all input filenames and their file types.
testnames != set +f; \
awk 'BEGIN { \
    for (i = 1; i < ARGC; i++) { \
        split(ARGV[i], names, /\//); \
        split(names[3], parts, /[._]/); \
        types[parts[1]]; \
        print names[3]; \
    } \
    delete types["vim9"]; \
    split("$(phonies)", scratch); \
    for (phony in scratch) \
        phonies[scratch[phony]]; \
    for (type in types) \
        print type ((type in phonies) ? "_" : ""); \
}' testdir/input/*.*

.PHONY: self-testing $(testnames)

$(testnames)::
	@echo $@ >> testdir/Xfilter

self-testing:: $(testnames)
	@echo self-testing > testdir/Xfilter

=== src/libvterm/Makefile ===
ifeq ($(shell uname),Darwin)
  LIBTOOL ?= glibtool
else
  LIBTOOL ?= libtool
endif

ifneq ($(VERBOSE),1)
  LIBTOOL +=--quiet
endif

override CFLAGS +=-Wall -Iinclude -std=c99 -Wpedantic -DINLINE=""

ifeq ($(shell uname),SunOS)
  override CFLAGS +=-D__EXTENSIONS__ -D_XPG6 -D__XOPEN_OR_POSIX
endif

ifeq ($(DEBUG),1)
  override CFLAGS +=-ggdb -DDEBUG
endif

ifeq ($(PROFILE),1)
  override CFLAGS +=-pg
  override LDFLAGS+=-pg
endif

CFILES=$(sort $(wildcard src/*.c))
HFILES=$(sort $(wildcard include/*.h))
OBJECTS=$(CFILES:.c=.lo)
LIBRARY=libvterm.la

BINFILES_SRC=$(sort $(wildcard bin/*.c))
BINFILES=$(BINFILES_SRC:.c=)

TBLFILES=$(sort $(wildcard src/encoding/*.tbl))
INCFILES=$(TBLFILES:.tbl=.inc)

HFILES_INT=$(sort $(wildcard src/*.h)) $(HFILES)

VERSION_CURRENT=0
VERSION_REVISION=0
VERSION_AGE=0

VERSION=0.3.3

PREFIX=/usr/local
BINDIR=$(PREFIX)/bin
LIBDIR=$(PREFIX)/lib
INCDIR=$(PREFIX)/include
MANDIR=$(PREFIX)/share/man
MAN3DIR=$(MANDIR)/man3

# Uncomment to check for memory access errors with valgrind.
# VALGRIND=1

all: $(LIBRARY) $(BINFILES)

$(LIBRARY): $(OBJECTS)
	$(LIBTOOL) --mode=link --tag=CC $(CC) -rpath $(LIBDIR) -version-info $(VERSION_CURRENT):$(VERSION_REVISION):$(VERSION_AGE) -o $@ $^ $(LDFLAGS)

src/%.lo: src/%.c $(HFILES_INT)
	$(LIBTOOL) --mode=compile --tag=CC $(CC) $(CFLAGS) -o $@ -c $<

src/encoding/%.inc: src/encoding/%.tbl
	perl -CSD tbl2inc_c.pl $< >$@

src/fullwidth.inc:
	@perl find-wide-chars.pl >$@

src/encoding.lo: $(INCFILES)

bin/%: bin/%.c $(LIBRARY)
	$(LIBTOOL) --mode=link --tag=CC $(CC) $(CFLAGS) -o $@ $< -lvterm $(LDFLAGS)

t/harness.lo: t/harness.c $(HFILES)
	$(LIBTOOL) --mode=compile --tag=CC $(CC) $(CFLAGS) -o $@ -c $<

t/harness: t/harness.lo $(LIBRARY)
	$(LIBTOOL) --mode=link --tag=CC $(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS) -static

.PHONY: test
test: $(LIBRARY) t/harness
	for T in `ls t/[0-9]*.test`; do echo "** $$T **"; perl t/run-test.pl $$T $(if $(VALGRIND),--valgrind) || exit 1; done

.PHONY: clean
clean:
	$(LIBTOOL) --mode=clean rm -f $(OBJECTS) $(INCFILES)
	$(LIBTOOL) --mode=clean rm -f t/harness.lo t/harness
	$(LIBTOOL) --mode=clean rm -f $(LIBRARY) $(BINFILES)

.PHONY: install
install: install-inc install-lib install-bin

install-inc:
	install -d $(DESTDIR)$(INCDIR)
	install -m644 $(HFILES) $(DESTDIR)$(INCDIR)
	install -d $(DESTDIR)$(LIBDIR)/pkgconfig
	sed -e "s,@INCDIR@,$(INCDIR)," -e "s,@LIBDIR@,$(LIBDIR)," -e "s,@VERSION@,$(VERSION)," <vterm.pc.in >$(DESTDIR)$(LIBDIR)/pkgconfig/vterm.pc

install-lib: $(LIBRARY)
	install -d $(DESTDIR)$(LIBDIR)
	$(LIBTOOL) --mode=install install $(LIBRARY) $(DESTDIR)$(LIBDIR)/$(LIBRARY)
	$(LIBTOOL) --mode=finish $(DESTDIR)$(LIBDIR)

install-bin: $(BINFILES)
	install -d $(DESTDIR)$(BINDIR)
	$(LIBTOOL) --mode=install install $(BINFILES) $(DESTDIR)$(BINDIR)/

# DIST CUT

DISTDIR=libvterm-$(VERSION)

distdir: $(INCFILES)
	mkdir __distdir
	cp LICENSE CONTRIBUTING __distdir
	mkdir __distdir/src
	cp src/*.c src/*.h src/*.inc __distdir/src
	mkdir __distdir/src/encoding
	cp src/encoding/*.inc __distdir/src/encoding
	mkdir __distdir/include
	cp include/*.h __distdir/include
	mkdir __distdir/bin
	cp bin/*.c __distdir/bin
	mkdir __distdir/t
	cp t/*.test t/harness.c t/run-test.pl __distdir/t
	sed "s,@VERSION@,$(VERSION)," <vterm.pc.in >__distdir/vterm.pc.in
	sed "/^# DIST CUT/Q" <Makefile >__distdir/Makefile
	mv __distdir $(DISTDIR)

TARBALL=$(DISTDIR).tar.gz

dist: distdir
	tar -czf $(TARBALL) $(DISTDIR)
	rm -rf $(DISTDIR)

dist+bzr:
	$(MAKE) dist VERSION=$(VERSION)+bzr`bzr revno`

distdir+bzr:
	$(MAKE) distdir VERSION=$(VERSION)+bzr`bzr revno`

=== src/po/Makefile ===
# Makefile for the Vim message translations.

# Include stuff found by configure.
include ../auto/config.mk

# Get LANGUAGES, MOFILES, MOCONVERTED and others.
include Make_all.mak

# Note: ja.sjis, *.cp1250 and zh_CN.cp936 are only for MS-Windows, they are
# not installed on Unix.

PACKAGE = vim
SHELL = /bin/sh
VIMPROG = ../vim

# MacOS sed is locale aware, set $LANG to avoid problems.
SED = LANG=C sed

# The OLD_PO_FILE_INPUT and OLD_PO_FILE_OUTPUT are for the new GNU gettext
# tools 0.10.37, which use a slightly different .po file format that is not
# compatible with Solaris (and old gettext implementations) unless these are
# set.  gettext 0.10.36 will not work!

# MSGFMTCMD is defined by Configure in ../auto/config.mk
XGETTEXT = OLD_PO_FILE_INPUT=yes OLD_PO_FILE_OUTPUT=yes xgettext
MSGMERGE = OLD_PO_FILE_INPUT=yes OLD_PO_FILE_OUTPUT=yes msgmerge

.SUFFIXES:
.SUFFIXES: .po .mo .pot .ck
.PHONY: all install uninstall prefixcheck originals converted check clean \
	checkclean distclean update-po $(LANGUAGES)

all: $(MOFILES) $(MOCONVERTED) $(MSGFMT_DESKTOP)

originals: $(MOFILES)

converted: $(MOCONVERTED)

.po.mo:
	$(MSGFMTCMD) -o $@ $<

.po.ck:
	$(VIMPROG) -u NONE --noplugins -e -s -X --cmd "set enc=utf-8" \
		-S check.vim -c "if error == 0 | q | else | num 2 | cq | endif" \
		$< >/dev/null
	touch $@

check: $(CHECKFILES)

# Installing for real.
install: $(MOFILES) $(MOCONVERTED)
	@$(MAKE) prefixcheck
	for lang in $(LANGUAGES); do \
	  dir=$(LOCALEDIR)/$$lang/; \
	  if test ! -x "$$dir"; then \
	    mkdir $$dir; chmod 755 $$dir; \
	  fi; \
	  dir=$(LOCALEDIR)/$$lang/LC_MESSAGES; \
	  if test ! -x "$$dir"; then \
	    mkdir $$dir; chmod 755 $$dir; \
	  fi; \
	  if test -r $$lang.mo; then \
	    $(INSTALL_DATA) $$lang.mo $$dir/$(PACKAGE).mo; \
	    chmod $(FILEMOD) $$dir/$(PACKAGE).mo; \
	  fi; \
	done

uninstall:
	@$(MAKE) prefixcheck
	for cat in $(MOFILES) $(MOCONVERTED); do \
	  cat=`basename $$cat`; \
	  lang=`echo $$cat | $(SED) 's/\$(CATOBJEXT)$$//'`; \
	  rm -f $(LOCALEDIR)/$$lang/LC_MESSAGES/$(PACKAGE).mo; \
	done

# Installing for local tryout into ../../runtime/lang.
tryoutinstall: $(MOFILES) $(MOCONVERTED)
	@$(MAKE) prefixcheck
	for lang in $(LANGUAGES); do \
	  dir=../../runtime/lang/$$lang/; \
	  if test ! -x "$$dir"; then \
	    mkdir $$dir; chmod 755 $$dir; \
	  fi; \
	  dir=../../runtime/lang/$$lang/LC_MESSAGES; \
	  if test ! -x "$$dir"; then \
	    mkdir $$dir; chmod 755 $$dir; \
	  fi; \
	  if test -r $$lang.mo; then \
	    cp $$lang.mo $$dir/$(PACKAGE).mo; \
	    chmod 644 $$dir/$(PACKAGE).mo; \
	  fi; \
	done

# Norwegian/Bokmal: "nb" is an alias for "no".
# Copying the file is not efficient, but I don't know of another way to make
# this work.
nb.po: no.po
	cp no.po nb.po

# Convert ja.po to create ja.sjis.po.  Requires doubling backslashes in the
# second byte.  Don't depend on sjiscorr, it should only be compiled when
# ja.sjis.po is outdated.
ja.sjis.po: ja.po
	@$(MAKE) sjiscorr
	rm -f $@
	iconv -f UTF-8 -t CP932 $? | ./sjiscorr > $@

sjiscorr: sjiscorr.c
	$(CC) -o sjiscorr sjiscorr.c

ja.euc-jp.po: ja.po
	iconv -f UTF-8 -t EUC-JP $? | \
		$(SED) -e 's/charset=[uU][tT][fF]-8/charset=EUC-JP/' \
			-e 's/# Original translations/# Generated from $?, DO NOT EDIT/' \
			> $@

# Convert cs.po to create cs.cp1250.po.
cs.cp1250.po: cs.po
	rm -f $@
	iconv -f ISO-8859-2 -t CP1250 $? | \
		$(SED) -e 's/charset=[iI][sS][oO]-8859-2/charset=CP1250/' \
			-e 's/# Original translations/# Generated from $?, DO NOT EDIT/' \
			> $@

# Convert pl.po to create pl.cp1250.po.
pl.cp1250.po: pl.po
	rm -f $@
	iconv -f ISO-8859-2 -t CP1250 $? | \
		$(SED) -e 's/charset=[iI][sS][oO]-8859-2/charset=CP1250/' \
			-e 's/# Original translations/# Generated from $?, DO NOT EDIT/' \
			> $@

# Convert pl.po to create pl.UTF-8.po.
pl.UTF-8.po: pl.po
	rm -f $@
	iconv -f ISO-8859-2 -t UTF-8 $? | \
		$(SED) -e 's/charset=[iI][sS][oO]-8859-2/charset=UTF-8/' \
			-e 's/# Original translations/# Generated from $?, DO NOT EDIT/' \
			> $@

# Convert sk.po to create sk.cp1250.po.
sk.cp1250.po: sk.po
	rm -f $@
	iconv -f ISO-8859-2 -t CP1250 $? | \
		$(SED) -e 's/charset=[iI][sS][oO]-8859-2/charset=CP1250/' \
			-e 's/# Original translations/# Generated from $?, DO NOT EDIT/' \
			> $@

# Convert zh_CN.UTF-8.po to create zh_CN.po.
zh_CN.po: zh_CN.UTF-8.po
	rm -f $@
	iconv -f UTF-8 -t GB2312 $? | \
		$(SED) -e 's/charset=[uU][tT][fF]-8/charset=GB2312/' \
			-e 's/# Original translations/# Generated from $?, DO NOT EDIT/' \
			> $@

# Convert zh_CN.UTF-8.po to create zh_CN.cp936.po.
# Set 'charset' to gbk to avoid that msfmt generates a warning.
# This used to convert from zh_CN.po, but that results in a conversion error.
zh_CN.cp936.po: zh_CN.UTF-8.po
	rm -f $@
	iconv -f UTF-8 -t CP936 $? | \
		$(SED) -e 's/charset=[uU][tT][fF]-8/charset=GBK/' \
			-e 's/# Original translations/# Generated from $?, DO NOT EDIT/' \
			> $@

# Convert zh_TW.UTF-8.po to create zh_TW.po.
zh_TW.po: zh_TW.UTF-8.po
	rm -f $@
	iconv -f UTF-8 -t BIG5 $? | \
		$(SED) -e 's/charset=[uU][tT][fF]-8/charset=BIG5/' \
			-e 's/# Original translations/# Generated from $?, DO NOT EDIT/' \
			> $@


# Convert zh_TW.UTF-8.po to create zh_TW.po with backslash characters.
# Requires doubling backslashes in the second byte.  Don't depend on big5corr,
# it should only be compiled when zh_TW.po is outdated.

#
#  06.11.23, added by Restorer
#  For more details, see:
#  https://github.com/vim/vim/pull/3261
#  https://github.com/vim/vim/pull/3476
#  https://github.com/vim/vim/pull/12153
#  (read all comments)
#
#  I checked the workability on the list of backslash characters
#  specified in zh_TW.UTF-8.po. It works.
#  But it is better to have someone native speaker check it.
#

#zh_TW.po: zh_TW.UTF-8.po
#	@$(MAKE) big5corr
#	rm -f $@
#	iconv -f UTF-8 -t BIG5 $? | ./big5corr > $@


# 06.11.23, added by Restorer
# See above in the zh_tw.po conversion section for backslashes.
#big5corr: big5corr.c
#	$(CC) -o big5corr big5corr.c


# Convert ko.UTF-8.po to create ko.po.
ko.po: ko.UTF-8.po
	rm -f $@
	iconv -f UTF-8 -t EUC-KR $? | \
		$(SED) -e 's/charset=[uU][tT][fF]-8/charset=EUC-KR/' \
			-e 's/# Original translations/# Generated from $?, DO NOT EDIT/' \
			> $@

# Convert ru.po to create ru.cp1251.po.
ru.cp1251.po: ru.po
	rm -f $@
	iconv -f UTF-8 -t CP1251 $? | \
		$(SED) -e 's/charset=[uU][tT][fF]-8/charset=CP1251/' \
			-e 's/# Original translations/# Generated from $?, DO NOT EDIT/' \
			> $@

# Convert uk.po to create uk.cp1251.po.
uk.cp1251.po: uk.po
	rm -f $@
	iconv -f UTF-8 -t CP1251 $? | \
		$(SED) -e 's/charset=[uU][tT][fF]-8/charset=CP1251/' \
			-e 's/# Original translations/# Generated from $?, DO NOT EDIT/' \
			> $@

prefixcheck:
	@if test "x" = "x$(prefix)"; then \
	  echo "******************************************"; \
	  echo "  Please use make from the src directory  "; \
	  echo "******************************************"; \
	  exit 1; \
	fi

clean: checkclean
	- rm -f core core.* *.old.po *.mo sjiscorr
	- rm -f LINGUAS vim.desktop gvim.desktop tmp_*desktop
	- rm -f ./allfiles
#	- rm -f big5corr

distclean: clean

checkclean:
	rm -f *.ck

PO_INPUTLIST = \
	../*.c \
	../if_perl.xs \
	../GvimExt/gvimext.cpp \
	../errors.h \
	../globals.h \
	../if_py_both.h \
	../vim.h \
	gvim.desktop.in \
	vim.desktop.in

$(PACKAGE).pot: $(PO_INPUTLIST) $(PO_VIM_INPUTLIST)
	# Convert the Vim scripts to (what looks like) Javascript.
	$(VIMPROG) -u NONE --not-a-term -S tojavascript.vim $(PACKAGE).pot \
		$(PO_VIM_INPUTLIST)
	@ echo ${PO_INPUTLIST} | tr ' ' '\n' > ./allfiles
	@ cat ./vim_to_js >> ./allfiles
	# Create vim.pot.
	$(XGETTEXT) --default-domain=$(PACKAGE) --output=$(PACKAGE).pot \
		--add-comments $(XGETTEXT_KEYWORDS) --files-from=./allfiles \
		--no-location --copyright-holder="$$(date +%Y), The Vim Project" \
		--package-name=Vim --msgid-bugs-address="vim-dev@vim.org"
	# Fix Vim scripts names, so that "gf" works.
	$(VIMPROG) -u NONE --not-a-term -S fixfilenames.vim $(PACKAGE).pot \
		$(PO_VIM_INPUTLIST)
	# Delete the temporary files.
	rm -f *.js ./vim_to_js allfiles

vim.desktop: vim.desktop.in $(POFILES)
	echo $(LANGUAGES) | tr " " "\n" |$(SED) -e '/\./d' | sort > LINGUAS
	$(MSGFMT) --desktop -d . --template vim.desktop.in -o tmp_vim.desktop
	rm -f LINGUAS
	if command -v desktop-file-validate; \
		then desktop-file-validate tmp_vim.desktop; fi
	mv tmp_vim.desktop vim.desktop

# The dependency on vim.desktop is only to avoid the two targets are build at
# the same time, which causes a race for the LINGUAS file.
gvim.desktop: gvim.desktop.in $(POFILES) vim.desktop
	echo $(LANGUAGES) | tr " " "\n" |$(SED) -e '/\./d' | sort > LINGUAS
	$(MSGFMT) --desktop -d . --template gvim.desktop.in -o tmp_gvim.desktop
	rm -f LINGUAS
	if command -v desktop-file-validate; \
		then desktop-file-validate tmp_gvim.desktop; fi
	mv tmp_gvim.desktop gvim.desktop

# Only original translations with default encoding should be updated.
# The files that are converted to a different encoding clearly state "DO NOT EDIT".
update-po: $(MOFILES:.mo=)

# Don't add a dependency here, we only want to update the .po files manually.
$(LANGUAGES):
	@$(MAKE) $(PACKAGE).pot
	if test ! -f $@.po.orig; then cp $@.po $@.po.orig; fi
	mv $@.po $@.po.old
	if $(MSGMERGE) $@.po.old $(PACKAGE).pot -o $@.po; then \
	    rm -f $@.po.old; \
	else \
	    echo "msgmerge for $@.po failed!"; mv $@.po.old $@.po; \
	fi


#######
# For translations of plug-ins
#######

# Preparing the POT file of the plug-in package
POT_PLUGPACKAGE_PATH = $(PWD)
$(PLUGPACKAGE).pot: $(PO_PLUG_INPUTLIST)
	$(VIMPROG) -u NONE --not-a-term -S tojavascript.vim \
		$(PLUGPACKAGE).pot $?
	$(XGETTEXT) --from-code=UTF-8 --default-domain=$(PLUGPACKAGE) \
		--package-name=$(PLUGPACKAGE) \
		--output-dir=$(POT_PLUGPACKAGE_PATH) \
		--output=$(PLUGPACKAGE).pot --files-from=./vim_to_js
	$(VIMPROG) -u NONE --not-a-term -S fixfilenames.vim \
		$(POT_PLUGPACKAGE_PATH)/$(PLUGPACKAGE).pot $?
	rm -f *.js ./vim_to_js

# Converting the PO file of the plug-in package to the binary format of the MO
MO_PLUGPACKAGE_PATH = $(PWD)
$(PLUGPACKAGE).mo: $(PO_PLUGPACKAGE)
	$(MSGFMTCMD) -o $(MO_PLUGPACKAGE_PATH)/$@ $?

# vim: set noet sw=8 ts=8 sts=0 wm=0 tw=0 ft=make:

=== src/testdir/Makefile ===
#
# Makefile to run all tests for Vim
#

# Use console or GUI.
VIMPROG = ../vim
XXDPROG = ../xxd/xxd
# VIMPROG = ../gvim

SCRIPTSOURCE = ../../runtime

# Comment out this line to see the verbose output of tests.
#
# Catches SwapExists to avoid hanging at the ATTENTION prompt.
REDIR_TEST_TO_NULL = --cmd 'au SwapExists * let v:swapchoice = "e"' | LC_ALL=C awk '/Executing Test_/{match($$0, "([0-9][0-9]:[0-9][0-9] *)?Executing Test_[^\\)]*\\)"); print substr($$0, RSTART, RLENGTH) "\r"; fflush()}'

# Uncomment this line to use valgrind for memory leaks and extra warnings.
#   The output goes into a file "valgrind.testN"
#   Vim should be compiled with EXITFREE to avoid false warnings.
#   This will make testing about 10 times as slow.
# VALGRIND = valgrind --tool=memcheck --leak-check=yes --num-callers=45 --log-file=valgrind.$*

# To execute one test, e.g. in gdb, use something like this:
# run -f -u util/unix.vim --gui-dialog-file guidialog -U NONE --noplugin --not-a-term -S runtest.vim test_name.vim

default: nongui

# The list of tests is common to all systems.
# This defines SCRIPTS_TINY_OUT, NEW_TESTS and NEW_TESTS_RES.
include Make_all.mak

# Explicit dependencies.
test_options_all.res: opt_test.vim

.SUFFIXES: .in .out .res .vim

nongui:	nolog tinytests newtests report

gui:	nolog tinytests newtests report

tiny:	nolog tinytests report

benchmark: $(SCRIPTS_BENCH)

report:
	@# without the +eval feature test_result.log is a copy of test.log
	@/bin/sh -c "if test -f test.log; \
		then cp test.log test_result.log; \
		else echo No failures reported > test_result.log; \
		fi"
	$(VIMPROG) -u NONE $(NO_INITS) -S util/summarize.vim messages $(REDIR_TEST_TO_NULL)
	@rm -f starttime
	@echo
	@echo 'Test results:'
	@cat test_result.log
	@/bin/sh -c "if test -f test.log; \
		then echo TEST FAILURE; exit 1; \
		else echo ALL DONE; \
		fi"

$(SCRIPTS_TINY_OUT) $(NEW_TESTS_RES): $(VIMPROG)

# For $ASAN_OPTIONS and $UBSAN_OPTIONS append the testname to it.
# This assumes $ASAN_OPTIONS contains log_path as last part of the environment variable
# For Github CI, those variables are set in .github/workflows/ci.yml

# Execute an individual new style test, e.g.:
# 	make test_largefile
$(NEW_TESTS):
	rm -f $@.res $(CLEANUP_FILES)
	@MAKEFLAGS=--no-print-directory $(MAKE) -f Makefile $@.res VIMPROG=$(VIMPROG) XXDPROG=$(XXDPROG) SCRIPTSOURCE=$(SCRIPTSOURCE)
	@cat messages
	@if test -f test.log; then \
		exit 1; \
	fi

# Run only tests specific for Vim9 script
test_vim9:
	rm -f test_vim9_*.res $(CLEANUP_FILES)
	@MAKEFLAGS=--no-print-directory $(MAKE) -f Makefile $(TEST_VIM9_RES) VIMPROG=$(VIMPROG) XXDPROG=$(XXDPROG) SCRIPTSOURCE=$(SCRIPTSOURCE)
	@cat messages
	@rm -f starttime
	@MAKEFLAGS=--no-print-directory $(MAKE) -f Makefile report VIMPROG=$(VIMPROG) XXDPROG=$(XXDPROG) SCRIPTSOURCE=$(SCRIPTSOURCE)
	@if test -f test.log; then \
		exit 1; \
	fi

RM_ON_RUN = test.out X* viminfo
RM_ON_START = test.ok benchmark.out
RUN_VIMPROG = VIMRUNTIME=$(SCRIPTSOURCE) $(VALGRIND) $(VIMPROG) -f $(GUI_FLAG) -u util/unix.vim $(NO_INITS) -s dotest.in

# Delete files that may interfere with running tests.  This includes some files
# that may result from working on the tests, not only from running them.
clean:
	-rm -rf *.out *.failed *.res *.rej *.orig XfakeHOME Xdir1 Xfind failed
	-rm -f opt_test.vim test_result.log $(CLEANUP_FILES)
	-rm -rf $(RM_ON_RUN) $(RM_ON_START)
	-rm -f valgrind.*
	-rm -f asan.* asan_test_*
	-rm -f guidialog guidialogfile

# Delete the files produced by benchmarking, so they can run again.
benchmarkclean:
	rm -f $(SCRIPTS_BENCH)

nolog:
	-rm -f test_result.log $(CLEANUP_FILES)


# Tiny tests.  Works even without the +eval feature.
tinytests: $(SCRIPTS_TINY_OUT)

.in.out:
	-rm -rf $*.failed test.ok $(RM_ON_RUN)
	cp $*.ok test.ok
	@# Sleep a moment to avoid that the xterm title is messed up.
	@# 200 msec is sufficient, but only modern sleep supports a fraction of
	@# a second, fall back to a second if it fails.
	@-/bin/sh -c "sleep .2 > /dev/null 2>&1 || sleep 1"
	if test -n "$${ASAN_OPTIONS}"; then \
		ASAN_OPTIONS="$${ASAN_OPTIONS}_$*" UBSAN_OPTIONS="$${UBSAN_OPTIONS}_$*" $(RUN_VIMPROG) $*.in $(REDIR_TEST_TO_NULL) ; \
	else \
		$(RUN_VIMPROG) $*.in $(REDIR_TEST_TO_NULL) ; \
	fi

	@# Check if the test.out file matches test.ok.
	@/bin/sh -c "if test -f test.out; then \
		  if diff test.out $*.ok; \
		  then mv -f test.out $*.out; \
		  else echo $* FAILED >>test.log; mv -f test.out $*.failed; \
		  fi \
		else echo $* NO OUTPUT >>test.log; \
		fi"
	@/bin/sh -c "if test -f valgrind; then\
		  mv -f valgrind valgrind.$*; \
		fi"
	-rm -rf X* test.ok viminfo


# New style of tests uses Vim script with assert calls.  These are easier
# to write and a lot easier to read and debug.
# Limitation: Only works with the +eval feature.
# Add --gui-dialog-file to avoid getting stuck in a dialog.
RUN_VIMTEST = VIMRUNTIME=$(SCRIPTSOURCE) $(VALGRIND) $(VIMPROG) -f $(GUI_FLAG) -u util/unix.vim --gui-dialog-file guidialog

newtests: newtestssilent
	@/bin/sh -c "if test -f messages; then cat messages; fi"

newtestssilent: $(NEW_TESTS_RES)


.vim.res:
	@echo "$(VIMPROG)" > vimcmd
	@echo "$(RUN_VIMTEST)" >> vimcmd
	if test -n "$${ASAN_OPTIONS}"; then \
		ASAN_OPTIONS="$${ASAN_OPTIONS}_$*" UBSAN_OPTIONS="$${UBSAN_OPTIONS}_$*" $(RUN_VIMTEST) $(NO_INITS) -S runtest.vim $*.vim $(REDIR_TEST_TO_NULL) ; \
	else \
		$(RUN_VIMTEST) $(NO_INITS) -S runtest.vim $*.vim $(REDIR_TEST_TO_NULL) ; \
	fi
	@rm vimcmd

test_gui.res: test_gui.vim
	@echo "$(VIMPROG)" > vimcmd
	@echo "$(RUN_GVIMTEST)" >> vimcmd
	if test -n "$${ASAN_OPTIONS}"; then \
		ASAN_OPTIONS="$${ASAN_OPTIONS}_$*" UBSAN_OPTIONS="$${UBSAN_OPTIONS}_$*" $(RUN_VIMTEST) -u NONE $(NO_INITS) -S runtest.vim $< ; \
	else \
		$(RUN_VIMTEST) -u NONE $(NO_INITS) -S runtest.vim $< ; \
	fi

	@rm vimcmd

test_gui_init.res: test_gui_init.vim
	@echo "$(VIMPROG)" > vimcmd
	@echo "$(RUN_GVIMTEST_WITH_GVIMRC)" >> vimcmd
	if test -n "$${ASAN_OPTIONS}"; then \
		ASAN_OPTIONS="$${ASAN_OPTIONS}_$*" UBSAN_OPTIONS="$${UBSAN_OPTIONS}_$*" $(RUN_VIMTEST) -u util/gui_preinit.vim -U util/gui_init.vim $(NO_PLUGINS) -S runtest.vim $< ; \
	else \
		$(RUN_VIMTEST) -u util/gui_preinit.vim -U util/gui_init.vim $(NO_PLUGINS) -S runtest.vim $< ; \
	fi
	@rm vimcmd

GEN_OPT_DEPS = util/gen_opt_test.vim ../optiondefs.h ../../runtime/doc/options.txt

opt_test.vim: $(GEN_OPT_DEPS)
	if test -n "$${ASAN_OPTIONS}"; then \
		ASAN_OPTIONS="$${ASAN_OPTIONS}_$*" UBSAN_OPTIONS="$${UBSAN_OPTIONS}_$*" $(VIMPROG) -e -s -u NONE $(NO_INITS) --nofork --gui-dialog-file guidialog -S $(GEN_OPT_DEPS) ; \
	else \
		$(VIMPROG) -e -s -u NONE $(NO_INITS) --nofork --gui-dialog-file guidialog -S $(GEN_OPT_DEPS) ; \
	fi
	@if test -f test.log; then \
		cat test.log; \
		exit 1; \
	fi

test_xxd.res:
	if test -n "$${ASAN_OPTIONS}"; then \
		XXD=$(XXDPROG); export XXD; ASAN_OPTIONS="$${ASAN_OPTIONS}_$*" UBSAN_OPTIONS="$${UBSAN_OPTIONS}_$*" $(RUN_VIMTEST) $(NO_INITS) -S runtest.vim test_xxd.vim ; \
	else \
		XXD=$(XXDPROG); export XXD; $(RUN_VIMTEST) $(NO_INITS) -S runtest.vim test_xxd.vim ; \
	fi

test_bench_regexp.res: test_bench_regexp.vim
	-rm -rf benchmark.out $(RM_ON_RUN)
	@# Sleep a moment to avoid that the xterm title is messed up.
	@# 200 msec is sufficient, but only modern sleep supports a fraction of
	@# a second, fall back to a second if it fails.
	@-/bin/sh -c "sleep .2 > /dev/null 2>&1 || sleep 1"
	if test -n "$${ASAN_OPTIONS}"; then \
		ASAN_OPTIONS="$${ASAN_OPTIONS}_$*" UBSAN_OPTIONS="$${UBSAN_OPTIONS}_$*" $(RUN_VIMTEST) $(NO_INITS) -S runtest.vim $*.vim $(REDIR_TEST_TO_NULL) ; \
	else \
		$(RUN_VIMTEST) $(NO_INITS) -S runtest.vim $*.vim $(REDIR_TEST_TO_NULL) ; \
	fi
	@/bin/sh -c "if test -f benchmark.out; then cat benchmark.out; fi"

=== src/xxd/Makefile ===
# The most simplistic Makefile

# SANITIZER_CFLAGS=-g -O0  -fsanitize-recover=all -fsanitize=address -fsanitize=undefined -fno-omit-frame-pointer

xxd: xxd.c
	$(CC) $(SANITIZER_CFLAGS) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -DUNIX -o xxd xxd.c $(LIBS)

clean:
	rm -f xxd xxd.o
	rm -rf xxd.dSYM

=== runtime/syntax/generator/Makefile ===
#
# Makefile for generate runtime/syntax/vim.vim
#
VIM_SRCDIR := ../../../src
RUN_VIMPROG := $(VIM_SRCDIR)/vim -N -u NONE -i NONE -n
TARGET := ../vim.vim
CHECK_HELP_DOC := 0

SRC :=	$(VIM_SRCDIR)/eval.c $(VIM_SRCDIR)/ex_cmds.h $(VIM_SRCDIR)/ex_docmd.c \
		$(VIM_SRCDIR)/fileio.c $(VIM_SRCDIR)/option.c $(VIM_SRCDIR)/syntax.c

export VIM_SRCDIR
export CHECK_HELP_DOC

.PHONY: generate check_doc clean
all: generate

generate: $(TARGET)

check_doc: CHECK_HELP_DOC := 1
check_doc: clean $(TARGET)

clean:
	rm -f vim.vim.rc $(TARGET)
	rm -f sanity_check.err generator.err

$(TARGET): vim.vim.rc update_date.vim
	@echo "Generating $(TARGET) ..."
	@cp -f vim.vim.rc $(TARGET)
	@$(RUN_VIMPROG) -S update_date.vim $(TARGET)
	@echo "done."

vim.vim.rc: gen_syntax_vim.vim vim.vim.base $(SRC)
	@echo "Generating vim.vim.rc ..."
	@rm -f sanity_check.err generator.err
	@$(RUN_VIMPROG) -S gen_syntax_vim.vim $(TARGET)
	@if test -f sanity_check.err ; then \
		echo ; \
		echo "Sanity errors:" ; \
		cat sanity_check.err ; \
	fi
	@if test -f generator.err ; then \
		echo ; \
		echo "Generator errors:" ; \
		cat generator.err ; \
	fi
	@if test -f sanity_check.err || test -f generator.err ; then \
		exit 1 ; \
	fi
	@echo "done."

=== debian/changelog ===
vim (2:9.1.1882-1~progress8.99u1) horok-backports; urgency=medium

  * Uploading to horok-backports, remaining changes:
    - Updating maintainer field.
    - Updating uploaders field.
    - Updating bugs field.
    - Updating vcs fields.
    - Setting BUILDER to maintainers@lists.progress-linux.org.
    - Building vim with python3.
    - Building vim-gtk3 without ruby.
    - Updating debversions for Progress Linux 1 to 10.
    - Disabling mouse.
    - Disabling BufReadPost.
    - Reading configuration files in /etc/vim/vimrc.d.
    - Enabling autoindent.
    - Enabling highlight whitespace.
    - Enabling hlsearch.
    - Enabling incsearch.
    - Enabling listchars.
    - Enabling noerrorbells.
    - Enabling powerline.
    - Building without wayland to fix FTBFS.
  * Merging upstream version 2:9.1.1882.
  * Merging debian version 2:9.1.1882-1.
  * Refreshing syntax-debversions.patch.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Wed, 12 Nov 2025 16:32:59 +0100

vim (2:9.1.1882-1) unstable; urgency=medium

  * Merge upstream patch v9.1.1882
  * Build without wayland on hurd

 -- James McCoy <jamessan@debian.org>  Mon, 27 Oct 2025 20:41:30 -0400

vim (2:9.1.1846-1~progress8.99u1) horok-backports; urgency=medium

  * Uploading to horok-backports, remaining changes:
    - Updating maintainer field.
    - Updating uploaders field.
    - Updating bugs field.
    - Updating vcs fields.
    - Setting BUILDER to maintainers@lists.progress-linux.org.
    - Building vim with python3.
    - Building vim-gtk3 without ruby.
    - Updating debversions for Progress Linux 1 to 10.
    - Disabling mouse.
    - Disabling BufReadPost.
    - Reading configuration files in /etc/vim/vimrc.d.
    - Enabling autoindent.
    - Enabling highlight whitespace.
    - Enabling hlsearch.
    - Enabling incsearch.
    - Enabling listchars.
    - Enabling noerrorbells.
    - Enabling powerline.
    - Building without wayland to fix FTBFS.
  * Merging upstream version 2:9.1.1846.
  * Merging debian version 2:9.1.1846-1.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Tue, 14 Oct 2025 19:34:32 +0200

vim (2:9.1.1829-1~progress8.99u1) horok-backports; urgency=medium

  * Uploading to horok-backports, remaining changes:
    - Updating maintainer field.
    - Updating uploaders field.
    - Updating bugs field.
    - Updating vcs fields.
    - Setting BUILDER to maintainers@lists.progress-linux.org.
    - Building vim with python3.
    - Building vim-gtk3 without ruby.
    - Updating debversions for Progress Linux 1 to 10.
    - Disabling mouse.
    - Disabling BufReadPost.
    - Reading configuration files in /etc/vim/vimrc.d.
    - Enabling autoindent.
    - Enabling highlight whitespace.
    - Enabling hlsearch.
    - Enabling incsearch.
    - Enabling listchars.
    - Enabling noerrorbells.
    - Enabling powerline.
    - Building without wayland to fix FTBFS.
  * Merging upstream version 2:9.1.1829.
  * Merging debian version 2:9.1.1829-1.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Fri, 10 Oct 2025 16:30:17 +0200

vim (2:9.1.1766-1~progress8.99u1) horok-backports; urgency=medium

  * Uploading to horok-backports, remaining changes:
    - Updating maintainer field.
    - Updating uploaders field.
    - Updating bugs field.
    - Updating vcs fields.
    - Setting BUILDER to maintainers@lists.progress-linux.org.
    - Building vim with python3.
    - Building vim-gtk3 without ruby.
    - Updating debversions for Progress Linux 1 to 10.
    - Disabling mouse.
    - Disabling BufReadPost.
    - Reading configuration files in /etc/vim/vimrc.d.
    - Enabling autoindent.
    - Enabling highlight whitespace.
    - Enabling hlsearch.
    - Enabling incsearch.
    - Enabling listchars.
    - Enabling noerrorbells.
    - Enabling powerline.
  * Merging upstream version 2:9.1.1766.
  * Merging debian version 2:9.1.1766-1.
  * Building without wayland to fix FTBFS.
  * Refreshing syntax-debversions.patch.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Wed, 24 Sep 2025 07:58:56 +0200

vim (2:9.1.1385-1~progress8.99u1) horok-backports; urgency=medium

  * Initial upload to horok-backports.
  * Updating maintainer field.
  * Updating uploaders field.
  * Updating bugs field.
  * Updating vcs fields.
  * Setting BUILDER to maintainers@lists.progress-linux.org.
  * Building vim with python3.
  * Building vim-gtk3 without ruby.
  * Updating debversions for Progress Linux 1 to 10.
  * Disabling mouse.
  * Disabling BufReadPost.
  * Reading configuration files in /etc/vim/vimrc.d.
  * Enabling autoindent.
  * Enabling highlight whitespace.
  * Enabling hlsearch.
  * Enabling incsearch.
  * Enabling listchars.
  * Enabling noerrorbells.
  * Enabling powerline.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Mon, 14 Jul 2025 18:39:58 +0200

=== debian/control ===
Source: vim
Section: editors
Priority: optional
Maintainer: Progress Linux Maintainers <maintainers@lists.progress-linux.org>
XSBC-Uploaders: Daniel Baumann <daniel.baumann@progress-linux.org>
XSBC-Original-Maintainer: Debian Vim Maintainers <team+vim@tracker.debian.org>
XSBC-Original-Uploaders:
 James McCoy <jamessan@debian.org>,
Bugs: mailto:maintainers@lists.progress-linux.org
Standards-Version: 4.7.0
Rules-Requires-Root: no
Build-Depends:
 autoconf,
 cscope <!nocheck>,
 debhelper-compat (= 13),
 libacl1-dev,
 libcanberra-dev,
 libgpmg1-dev [linux-any],
 libgtk-3-dev,
 liblua5.1-dev,
 libmotif-dev,
 libperl-dev,
 libselinux1-dev [linux-any],
 libsodium-dev,
 libncurses-dev,
# Needed to run libvterm's tests
 libtool-bin <!nocheck>,
 locales-all <!nocheck>,
 lua5.1,
 ncurses-term <!nocheck>,
 procps <!nocheck>,
 python3-dev,
 ruby [!alpha !ia64] <!pkg.vim.noruby>,
 ruby-dev [!alpha !ia64] <!pkg.vim.noruby>,
 tcl-dev,
Build-Conflicts:
 autoconf2.13,
Build-Depends-Indep:
 docbook-utils,
 docbook-xml,
 ghostscript,
# Explicitly depend on lynx since docbook2txt requires it, even though its
# Depends suggests otherwise (c.f., #387035)
 lynx,
 pdf2svg,
Vcs-Browser: https://git.progress-linux.org/horok-backports/vim
Vcs-Git: https://git.progress-linux.org/horok-backports/vim
XSBC-Original-Vcs-Browser: https://salsa.debian.org/vim-team/vim
XSBC-Original-Vcs-Git: https://salsa.debian.org/vim-team/vim.git
Homepage: https://www.vim.org/

Package: vim-common
Priority: important
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Recommends:
 xxd,
 vim | vim-gtk3 | vim-motif | vim-nox | vim-tiny,
Breaks: vim-runtime (<< 2:9.0.1658-1~)
Replaces: vim-runtime (<< 2:9.0.1658-1~)
Description: Vi IMproved - Common files
 Vim is an almost compatible version of the UNIX editor Vi.
 .
 This package contains files shared by all non GUI-enabled vim variants
 available in Debian.  Examples of such shared files are: manpages and
 configuration files.

Package: vim-gui-common
Architecture: all
Multi-Arch: foreign
Recommends:
 vim-gtk3 | vim-motif,
Depends:
 ${misc:Depends},
Description: Vi IMproved - Common GUI files
 Vim is an almost compatible version of the UNIX editor Vi.
 .
 This package contains files shared by all GUI-enabled vim
 variants available in Debian.  Examples of such shared files are:
 gvimtutor, icons, and desktop environments settings.

Package: vim-runtime
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Breaks:
 vim-tiny (<< ${source:Version}),
Recommends:
 vim | vim-gtk3 | vim-motif | vim-nox | vim-tiny,
Enhances:
 vim-tiny,
Description: Vi IMproved - Runtime files
 Vim is an almost compatible version of the UNIX editor Vi.
 .
 This package contains vimtutor and the architecture independent runtime
 files, used, if available, by all vim variants available in Debian.
 Example of such runtime files are: online documentation, rules for
 language-specific syntax highlighting and indentation, color schemes,
 and standard plugins.

Package: vim-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: Vi IMproved - HTML documentation
 Vim is an almost compatible version of the UNIX editor Vi.
 .
 This package contains the HTML version of the online documentation.  It is
 built from the runtime/doc directory of the source tree.

Package: vim-tiny
Priority: important
Architecture: any
Depends:
 vim-common (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 indent,
Provides:
 editor,
Description: Vi IMproved - enhanced vi editor - compact version
 Vim is an almost compatible version of the UNIX editor Vi.
 .
 This package contains a minimal version of Vim compiled with no GUI and
 a small subset of features. This package's sole purpose is to provide
 the vi binary for base installations.
 .
 If a vim binary is wanted, try one of the following more featureful
 packages: vim, vim-nox, vim-motif, or vim-gtk3.

Package: vim
Architecture: any
Depends:
 vim-common (= ${source:Version}),
 vim-runtime (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 ctags,
 vim-doc,
 vim-scripts,
Provides:
 editor,
Description: Vi IMproved - enhanced vi editor
 Vim is an almost compatible version of the UNIX editor Vi.
 .
 Many new features have been added: multi level undo, syntax
 highlighting, command line history, on-line help, filename
 completion, block operations, folding, Unicode support, etc.
 .
 This package contains a version of vim compiled with a rather
 standard set of features.  This package does not provide a GUI
 version of Vim.  See the other vim-* packages if you need more
 (or less).

Package: vim-gtk3
Architecture: any
Depends:
 vim-common (= ${source:Version}),
 vim-gui-common (= ${source:Version}),
 vim-runtime (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 cscope,
 fonts-dejavu,
 gnome-icon-theme,
 vim-doc,
Provides:
 editor,
 gvim (= ${binary:Version}),
 vim (= ${binary:Version}),
 vim-lua (= ${binary:Version}),
 vim-perl (= ${binary:Version}),
 vim-python3 (= ${binary:Version}),
 ${vim:Ruby-Provides},
 vim-tcl (= ${binary:Version}),
Description: Vi IMproved - enhanced vi editor - with GTK3 GUI
 Vim is an almost compatible version of the UNIX editor Vi.
 .
 Many new features have been added: multi level undo, syntax
 highlighting, command line history, on-line help, filename
 completion, block operations, folding, Unicode support, etc.
 .
 This package contains a version of vim compiled with a GTK3 GUI
 and support for scripting with Lua, Perl, Python 3,${vim:Ruby-Desc} and Tcl.

Package: vim-nox
Architecture: any
Depends:
 vim-common (= ${source:Version}),
 vim-runtime (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 cscope,
 vim-doc,
Provides:
 editor,
 vim (= ${binary:Version}),
 vim-lua (= ${binary:Version}),
 vim-perl (= ${binary:Version}),
 vim-python3 (= ${binary:Version}),
 ${vim:Ruby-Provides},
 vim-tcl (= ${binary:Version}),
Description: Vi IMproved - enhanced vi editor - with scripting languages support
 Vim is an almost compatible version of the UNIX editor Vi.
 .
 Many new features have been added: multi level undo, syntax
 highlighting, command line history, on-line help, filename
 completion, block operations, folding, Unicode support, etc.
 .
 This package contains a version of vim compiled with support for
 scripting with Lua, Perl, Python 3,${vim:Ruby-Desc} and Tcl but no GUI.

Package: vim-motif
Architecture: any
Depends:
 vim-common (= ${source:Version}),
 vim-gui-common (= ${source:Version}),
 vim-runtime (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 cscope,
 vim-doc,
Provides:
 editor,
 gvim (= ${binary:Version}),
 vim (= ${binary:Version}),
 vim-lua (= ${binary:Version}),
 vim-perl (= ${binary:Version}),
 vim-python3 (= ${binary:Version}),
 ${vim:Ruby-Provides},
 vim-tcl (= ${binary:Version}),
Description: Vi IMproved - enhanced vi editor - with Motif GUI
 Vim is an almost compatible version of the UNIX editor Vi.
 .
 Many new features have been added: multi level undo, syntax
 highlighting, command line history, on-line help, filename
 completion, block operations, folding, Unicode support, etc.
 .
 This package contains a version of vim compiled with a Motif GUI
 and support for scripting with Lua, Perl, Python 3,${vim-Ruby-Desc} and Tcl.

Package: xxd
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: tool to make (or reverse) a hex dump
 xxd creates a hex dump of a given file or standard input.  It can also convert
 a hex dump back to its original binary form.

=== debian/rules ===
#!/usr/bin/make -f

export DH_OPTIONS

# Upstream handles the _FORTIFY_SOURCE flag on their own
DEB_BUILD_MAINT_OPTIONS = hardening=+all,-fortify future=+lfs

include /usr/share/dpkg/default.mk

BUILDER = maintainers@lists.progress-linux.org

# Work around #1082125
ifeq (s390x,$(DEB_HOST_ARCH))
  CFLAGS += -O1
endif

MAKETEST = no
ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  MAKETEST = yes
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  MAKEFLAGS += -j$(NUMJOBS)
endif

RUBY_SUBSTVARS = -Vvim:Ruby-Provides= -Vvim:Ruby-Desc=
RUBY_CFGFLAGS = --disable-ruby

# Set to TEST_SKIP_PAT=<vim pattern> to exclude running tests matching the pattern
EXCLUDE_PAT = TEST_SKIP_PAT='Test_crash1\|glvs\|termdebug'

CFGFLAGS = --prefix=/usr --mandir='$${prefix}'/share/man --without-local-dir
CFGFLAGS += --with-modified-by="$(BUILDER)"
CFGFLAGS += --with-compiledby="$(BUILDER)"
CFGFLAGS += --enable-fail-if-missing
CFGFLAGS += --with-global-runtime='/var/lib/vim/addons,/etc/vim,$$VIM/vimfiles'

TINYFLAGS = --with-features=small
TINYFLAGS += --disable-gui
TINYFLAGS += --disable-xsmp
TINYFLAGS += --disable-xsmp-interact
TINYFLAGS += --disable-netbeans
TINYFLAGS += --disable-gpm
TINYFLAGS += --enable-nls
TINYFLAGS += --enable-acl
TINYFLAGS += --disable-terminal
TINYFLAGS += --disable-canberra
TINYFLAGS += --disable-libsodium

OPTFLAGS = --enable-cscope
ifeq ($(DEB_HOST_ARCH_OS),linux)
    OPTFLAGS += --enable-gpm
    OPTFLAGS += --enable-selinux --disable-smack
    TINYFLAGS += --enable-selinux --disable-smack
else
    OPTFLAGS += --disable-gpm
endif
OPTFLAGS += --with-features=huge
OPTFLAGS += --enable-acl
OPTFLAGS += --enable-terminal
OPTFLAGS += --enable-libsodium

NOXFLAGS = --without-x
NOXFLAGS += --enable-gui=no
NOXFLAGS += --disable-canberra
NOXFLAGS += --enable-socketserver
NOXFLAGS += --without-wayland

GUIFLAGS = --with-x
GUIFLAGS += --enable-xim
GUIFLAGS += --enable-canberra
GUIFLAGS += --without-wayland

GTK3FLAGS = --enable-gui=gtk3
GTK3FLAGS += --enable-gtk3-check
GTK3FLAGS += --disable-gnome-check
GTK3FLAGS += --disable-motif-check
GTK3FLAGS += --disable-motif-check
GTK3FLAGS += --disable-fontset
GTK3FLAGS += --enable-socketserver

MOTIFFLAGS = --enable-gui=motif
MOTIFFLAGS += --disable-gtk2-check
MOTIFFLAGS += --disable-gtk3-check
MOTIFFLAGS += --disable-gnome-check
MOTIFFLAGS += --disable-motif-check
MOTIFFLAGS += --enable-motif-check
MOTIFFLAGS += --enable-fontset

NOINTERPFLAGS = --disable-luainterp
NOINTERPFLAGS += --disable-mzschemeinterp
NOINTERPFLAGS += --disable-perlinterp
NOINTERPFLAGS += --enable-python3interp --with-python3-config-dir=$(shell python3-config --configdir)
NOINTERPFLAGS += --disable-pythoninterp
NOINTERPFLAGS += --disable-rubyinterp
NOINTERPFLAGS += --disable-tclinterp

ALLINTERPFLAGS = --enable-luainterp
ALLINTERPFLAGS += --disable-mzschemeinterp
ALLINTERPFLAGS += --enable-perlinterp
ALLINTERPFLAGS += --enable-python3interp --with-python3-config-dir=$(shell python3-config --configdir)
ALLINTERPFLAGS += --disable-pythoninterp
ALLINTERPFLAGS += --enable-tclinterp
ALLINTERPFLAGS += --with-tclsh=/usr/bin/tclsh

# Each vim-xxx package is said to be a vim variant and contains only a vim
# binary built with some compile-time options. Makefile VARIANTS below are
# one-to-one with those packages with the exception of "vim-basic". In this
# Makefile vim-basic is used to build 4 packages: "vim", "vim-runtime",
# "vim-common", "vim-gui-common". "vim-tiny" is the only variant package not
# depending on vim-runtime.

VARIANTS += vim-tiny
VARIANTS += vim-gtk3
VARIANTS += vim-motif
VARIANTS += vim-nox
VARIANTS += vim-basic

ifneq ($(origin VARIANT), undefined)
  VARIANTS = $(VARIANT) vim-basic
endif

CFLAGS += -DSYS_VIMRC_FILE="'\"/etc/vim/vimrc\"'" -DSYS_GVIMRC_FILE="'\"/etc/vim/gvimrc\"'"

CFLAGS_vim-basic = $(CFLAGS)
CFGFLAGS_vim-basic = $(CFGFLAGS) $(OPTFLAGS) $(NOXFLAGS) $(NOINTERPFLAGS)

CFLAGS_vim-tiny = $(CFLAGS) -DTINY_VIMRC -DSYS_TINYRC_FILE="'\"/etc/vim/vimrc.tiny\"'"
CFGFLAGS_vim-tiny = $(CFGFLAGS) $(TINYFLAGS)

CFLAGS_vim-gtk3 = $(CFLAGS)
CFGFLAGS_vim-gtk3 = $(CFGFLAGS) $(OPTFLAGS) $(GUIFLAGS) $(ALLINTERPFLAGS) $(GTK3FLAGS) $(RUBY_CFGFLAGS)

CFLAGS_vim-motif = $(CFLAGS)
CFGFLAGS_vim-motif = $(CFGFLAGS) $(OPTFLAGS) $(GUIFLAGS) $(MOTIFFLAGS) $(ALLINTERPFLAGS) $(RUBY_CFGFLAGS)

CFLAGS_vim-nox = $(CFLAGS)
CFGFLAGS_vim-nox = $(CFGFLAGS) $(OPTFLAGS) $(NOXFLAGS) $(ALLINTERPFLAGS) $(RUBY_CFGFLAGS)

NAME = vim
# Convert x.y.z to x.y
VERSION = $(basename $(DEB_VERSION_UPSTREAM))
VIMMAJOR = $(basename $(VERSION))
VIMCUR = $(NAME)$(subst .,,$(VERSION))
LANGS = da de fr it ja pl ru tr

DOT_IN_DEPS = debian/vim-runtime.postrm
DOT_IN_DEPS += debian/vim-runtime.preinst
DOT_IN_DEPS_TINY = debian/tiny/vimrc.tiny

foreach-variant = \
  set -e; for v in $(VARIANTS); do \
    $1; \
  done

%:
	dh $@

update-changelog:
	dh_testdir
	wget -O debian/changelog.upstream http://ftp.vim.org/pub/vim/patches/$(VERSION)/README

override_dh_auto_clean:
# The vim-basic variant is always enabled, so we can rely on it when checking
# whether we can call "make distclean".  The config.cache check is to avoid
# calling make when configure has not run, otherwise make will run configure to
# generate an include file
	[ ! -f src/vim-basic/auto/config.cache ] || make distclean
	[ ! -f debian/configure.dist ] || mv debian/configure.dist src/auto/configure
	find src/testdir -name '*.pyc' -delete
	for v in $(VARIANTS); do \
	  if [ "$${v}" = vim-basic ]; then \
	    [ ! -L src/"$${v}"/po ] || $(MAKE) -C src/"$${v}"/po clean; \
	  fi; \
	  rm -rf src/"$${v}"; \
	done
	rm -f $(DOT_IN_DEPS)
	rm -f $(DOT_IN_DEPS_TINY)

override_dh_auto_configure-indep: autoconf-stamp
	$(MAKE) -f debian/rules configure-vim-basic

override_dh_auto_configure-arch: autoconf-stamp
	$(call foreach-variant, $(MAKE) -f debian/rules configure-"$${v}")

override_dh_auto_build-indep: autoconf-stamp
override_dh_auto_build-indep:
	$(MAKE) -f debian/rules build-vim-basic
	$(MAKE) -C runtime/doc html
	$(MAKE) -C debian/policy text html
	$(MAKE) -C src/po vim.pot VIMPROG=$(CURDIR)/src/vim-basic/vim

override_dh_auto_build-arch: autoconf-stamp
	$(call foreach-variant, $(MAKE) -f debian/rules build-"$${v}")
	$(MAKE) -C src/vim-basic xxd/xxd

override_dh_auto_test-indep:

override_dh_auto_test-arch:
	$(call foreach-variant, $(MAKE) -f debian/rules test-"$${v}")

autoconf-stamp:
	dh_testdir
	[ -f debian/configure.dist ] || cp src/auto/configure debian/configure.dist
# The autoconf target generates a new configure, and touches some other
# configure-related things.  Need to run scratch afterward or timestamps
# will be off and the next make that runs will think it needs to run
# configure.  This breaks parallel builds since two configures are being run
# in the same directory at the same time instead of in their own shadow
# directories.
	$(MAKE) -C src autoconf
	$(MAKE) -C src scratch
	touch $@

src/vim-%: VARIANT=vim-$*
src/vim-%:
	$(MAKE) -C src shadow SHADOWDIR=$(VARIANT)

configure-vim-%: VARIANT=vim-$*
configure-vim-%: autoconf-stamp
configure-vim-%:
	$(MAKE) -f debian/rules src/$(VARIANT)
	cd src/$(VARIANT) && LDFLAGS="$(LDFLAGS)" CPPFLAGS="$(CPPFLAGS)" CFLAGS="$(CFLAGS_$(VARIANT))" ./configure $(CFGFLAGS_$(VARIANT))

build-vim-%: VARIANT=vim-$*
build-vim-%: configure-$(VARIANT)
build-vim-%:
	$(MAKE) -C src/$(VARIANT)
	$(MAKE) -C runtime/doc tags VIMPROG=$(CURDIR)/src/$(VARIANT)/vim

test-vim-%: VARIANT=vim-$*
test-vim-%:
	:
ifeq (yes,$(MAKETEST))
# Sanitize LC_* env so they don't leak through to child processes and cause problems in build chroots (e.g., missing locales)
# and set sane values for TERM/LC_ALL/LANG
	for e in ADDRESS COLLATE CTYPE IDENTIFICATION MEASUREMENT MESSAGES MONETARY NAME NUMERIC PAPER TELEPHONE TIME; do \
	  unset LC_$${e}; \
	done; \
	env $(EXCLUDE_PAT) TERM=xterm LC_ALL=C.UTF-8 LANG=C.UTF-8 $(MAKE) -j1 -C src/$(VARIANT) test
endif

override_dh_auto_install-arch:
